#!/bin/bash
#set -x
function log() {
   logger "$*"
   echo "$*"
}
      
# check if already running
if [ "$(pidof -x "$0" -o $$ -o $PPID -o %PPID)" != "" ] ; then
   log "ERROR: $0 laeuft bereits"
   exit
fi

source /etc/vdr.d/conf/gen2vdr.cfg

# check if undo is possible
# Link for undo
SRC_DIR="$(readlink "${VIDEO}/rec_undo")"
SRC_DIR="${SRC_DIR%/}"

[ -e "${VIDEO}/rec_undo" ] && rm -f "${VIDEO}/rec_undo"

if [ ! -d "$SRC_DIR" ] ; then
   log "ERROR: UNDO UrsprungsVerzeichnis existiert nicht"
   exit
fi

TARGET_DIR="$(readlink "${SRC_DIR}/undo.link")"
if [ ! -d "${TARGET_DIR}" ] ; then
   log "ERROR: UNDO ZielVerzeichnis existiert nicht"
   exit
fi

cd "$TARGET_DIR"
du -hsb [0-9][0-9][0-9].vdr > "${SRC_DIR}/undo.info.new"

if [ "$(diff -uN "${SRC_DIR}/undo.info.new" "${SRC_DIR}/undo.info")" != "" ] ; then
   log "ERROR: UNDO ZielVerzeichnis hat sich geaendert"
   exit
fi
# move files
cd "$SRC_DIR"
for i in [0-9][0-9][0-9].vdr.undo ; do
   mv "$(readlink "$i")" "${i%.undo}"
   rm -f "$i"
done

# save marks, index and info
for i in marks.vdr index.vdr info.vdr.merged ; do
   if [ -e "${SRC_DIR}/${i}.undo" ] ; then
      cp -pf "${SRC_DIR}/${i}.undo" "${TARGET_DIR}/${i}"
      rm -f "${SRC_DIR}/${i}.undo"
   else
      [ -e "${TARGET_DIR}/${i}" ] && rm -f "${TARGET_DIR}/${i}"
   fi
done

rm -f undo.*

cd /
# create undo Link
SRC_REC="${SRC_DIR%.del}.rec"

mv -f "$SRC_DIR" "$SRC_REC"
touch /video/.update

log "Die Trennung wurde vollzogen"

screen -dm sh -c "sleep 10; touch /video/.update"
